package com.its.op.service.its.ifsc;

import com.its.op.dao.repository.its.ifsc.TbIfscTrafRepository;
import com.its.op.dao.repository.its.ifsc.TbIfscTrafSimpleRepository;
import com.its.op.dto.its.common.TrafDto;
import com.its.op.dto.its.ifsc.TbIfscTrafDto;
import com.its.op.entity.its.ifsc.TbIfscTraf;
import com.its.op.entity.its.ifsc.TbIfscTrafSimple;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIfscTrafService {

    private final TbIfscTrafRepository repo;
    private final TbIfscTrafSimpleRepository trafRepo;

    // 데이터 1건 조회, 없으면 exception
    private TbIfscTraf requireOne(Long id) throws NoSuchElementException {
        Optional<TbIfscTraf> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIfscTrafDto> findAll() {
        List<TbIfscTrafDto> result = new ArrayList<>();
        List<TbIfscTraf> data = this.repo.findAll();
        for (TbIfscTraf entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbIfscTrafDto findById(Long id) {
        TbIfscTraf entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 소통정보조회
     * @return
     */
    public List<TrafDto> findAllTraf() {
        List<TrafDto> result = new ArrayList<>();
        List<TbIfscTrafSimple> data = this.trafRepo.findAll();
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }
}
